package com.cyksj.service.relation;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cyksj.model.entity.GoodsDonSku;
import com.cyksj.model.entity.GroupsRelation;
import com.cyksj.model.entity.NetflixUserAccountStatusRecord;
import com.cyksj.model.manage.views.AccountView;
import com.cyksj.model.request.SpecialGoodsTicketReq;
import com.cyksj.model.request.TicketLoginReq;
import com.cyksj.model.views.RenewalView;
import com.cyksj.model.views.UserRecommendGoodsFrontView;
import com.ejlchina.searcher.SearchResult;

import java.util.List;

/*
 *项目名: netflix
 *文件名: GroupRelationFrontService
 *创建者: JavaZou
 *创建时间:2022/12/29 15:42
 */
public interface GroupRelationFrontService {
	SearchResult<RenewalView> getMyTicket(long userId, Boolean isLoginPopularize, String customId, String account, String orderNo, Integer cmt);

	Boolean isJoinCorpWx(Long userId, Boolean isJoin, Boolean noCoupon);

	GroupsRelation getSimilarExpiredGroupRelation(GoodsDonSku sku, List<Long> errorsRelationIds, String ip);

	Page<UserRecommendGoodsFrontView> getRecommendGoodsViews(Boolean isPayNf, List<Long> filter_goods_id, Boolean filterCourseGoods, Integer start, Integer limit);

	/**
	 * 通过邮件发送课程
	 */
	void sendCourseWare(SpecialGoodsTicketReq request) throws Exception;

	/**
	 * 获取车票座位
	 */
	GroupsRelation getRelation(Long payRelationId, Long userId, GoodsDonSku sku, String ip);

	/**
	 * 获取车票账号登录 验证码
	 */
	String getAiVerifyCode(TicketLoginReq loginReq) throws Exception;


	void checkGroupsAvailParkingNum(Long skuId, Long groupsId, Integer availableParkingNum, Integer maxNum);

	/**
	 * 调整指定规格车队下次可 停用车位数的时间
	 */
	void adjustGroupsParkingTime(Long relationId, GoodsDonSku sku);

	void setGroupsTripsParkingTimeEmpty(GoodsDonSku sku, Long relationId);

	Integer getUserCodeNumBySkuId(Long userId, Long skuId, Boolean isHasVerifyCode);

	List<RenewalView>  getHasPayGoods(long userId);

	List<RenewalView> getExpiryRenewalNotify(Long userId);

	void getCollegeStudentUserGptTicket(Long userId);

	RenewalView getTicketDetail(long userId, Long relationId);

	GroupsRelation ticketLogin(TicketLoginReq loginReq);

	String outsideTicketVerify(TicketLoginReq loginReq);

	String getNfHouseholdDevice(long userId, Long relationId) throws Exception;

	String getVerifyCode(String account) throws Exception;

	void changeTicket(long userId, Long relationId);

	AccountView getTempAccount(long userId, Long relationId);

	void nfErrorAccountSubmit(long userId, Long relationId);

	Integer getNetflixErrorAccountStatus(long userId, Long relationId);

	List<NetflixUserAccountStatusRecord> getUserNetflixSubmitRecord(long userId);

	/**
	 * 获取试用车票
	 *
	 * @param userId
	 * @param trialSkuId
	 * @return
	 */
	Long getTrialTicketByUserIdAndGoodsId(Long userId, Long trialSkuId, Integer ticketType);
}
